/*
  Copyright (c) 2005 by Jakob Schroeter <js@camaya.net>
  This file is part of the joox project. http://camaya.net/joox

  This software is distributed under a license. The full license
  agreement can be found in the file LICENSE in this distribution.
  This software may not be copied, modified, sold or distributed
  other than expressed in the named license agreement.

  This software is distributed without any warrenty.
*/

#ifndef CONTACTLIST_H_
#define CONTACTLIST_H_

#include <gloox/jid.h>
#include <gloox/rosterlistener.h>
#include <gloox/rostermanager.h>

#include <FL/Fl_Widget.H>

using namespace gloox;

class Fl_Multi_Browser;

class ContactList : public Fl_Widget, public RosterListener
{
  public:
    /**
     *
     */
    ContactList( int x, int y, int w, int h, const char *label );

    /**
     *
     */
    virtual ~ContactList();

    /**
     *
     */
    virtual void draw();

    // reimplemented from RosterListener
    virtual void itemAdded( const std::string &jid );
    virtual void itemSubscribed( const std::string &jid );
    virtual void itemRemoved( const std::string &jid );
    virtual void itemUpdated( const std::string &jid );
    virtual void itemUnsubscribed( const std::string &jid );
    virtual void roster( const Roster &roster );
    virtual void presenceUpdated( const RosterItem& item, int status, const std::string& msg );
    virtual void itemAvailable( const RosterItem &item, const std::string &msg );
    virtual void itemUnavailable( const RosterItem &item, const std::string &msg );
    virtual bool subscriptionRequest( const std::string &jid, const std::string &msg );
    virtual bool unsubscriptionRequest( const std::string &jid, const std::string &msg );
    virtual void nonrosterPresenceReceived( const gloox::JID& jid );
  private:
    Fl_Multi_Browser *m_list;
};

#endif // CONTACTLIST_H_
