/*
  Copyright (c) 2005 by Jakob Schroeter <js@camaya.net>
  This file is part of the joox project. http://camaya.net/joox

  This software is distributed under a license. The full license
  agreement can be found in the file LICENSE in this distribution.
  This software may not be copied, modified, sold or distributed
  other than expressed in the named license agreement.

  This software is distributed without any warrenty.
*/

#ifndef JOOX_H_
#define JOOX_H_

#include <FL/Fl_Window.H>

#include <gloox/client.h>
#include <gloox/connectionlistener.h>
using namespace gloox;

class ContactList;

class Joox : public Fl_Window, ConnectionListener
{
  public:
    /**
     *
     */
    Joox( int x, int y );

    /**
     * Virtual destructor.
     */
    virtual ~Joox();

    void connect();
    void disconnect();
    void xmlconsole();
    void quit();

    // reimplemented from ConnectionListener
    virtual void onConnect();

    // reimplemented from ConnectionListener
    virtual void onDisconnect( ConnectionError e );

    // reimplemented from ConnectionListener
    virtual bool onTLSConnect( const CertInfo &info ) { return true; };

  private:
    friend void connect_cb( Fl_Widget*, void* );
    friend void disconnect_cb( Fl_Widget*, void* );
    friend void xmlconsole_cb( Fl_Widget*, void* );
    friend void quit_cb( Fl_Widget*, void* );
    friend void timeout_cb( void *v );

    ContactList *m_contactList;
    Client *m_client;

    bool m_xml;
};

#endif // JOOX_H_
