/*
  Copyright (c) 2005 by Jakob Schroeter <js@camaya.net>
  This file is part of the joox project. http://camaya.net/joox

  This software is distributed under a license. The full license
  agreement can be found in the file LICENSE in this distribution.
  This software may not be copied, modified, sold or distributed
  other than expressed in the named license agreement.

  This software is distributed without any warrenty.
*/


#include "xmlconsole.h"

#include <gloox/logsink.h>

#include <FL/Fl_Text_Display.H>
#include <FL/Fl_Text_Buffer.H>

XMLConsole::XMLConsole( Client *parent, int x, int y )
  : Fl_Window( x, y ), m_parent( parent )
{
  LogSink::instance().registerLogHandler( LOG_DEBUG, LOG_XML_INCOMING | LOG_XML_OUTGOING, this );
  Fl_Text_Display *o = new Fl_Text_Display( 10, 10, 580, 480 );
  m_buffer = new Fl_Text_Buffer();
  o->buffer( m_buffer );
}

XMLConsole::~XMLConsole()
{
}

void XMLConsole::handleLog( LogLevel level, LogArea area, const std::string &xml )
{
  m_buffer->append( xml.c_str() );
  m_buffer->append( "\n" );
}
