/*
  Copyright (c) 2005 by Jakob Schroeter <js@camaya.net>
  This file is part of the joox project. http://camaya.net/joox

  This software is distributed under a license. The full license
  agreement can be found in the file LICENSE in this distribution.
  This software may not be copied, modified, sold or distributed
  other than expressed in the named license agreement.

  This software is distributed without any warrenty.
*/

#ifndef XMLCONSOLE_H_
#define XMLCONSOLE_H_

#include <gloox/client.h>
#include <gloox/loghandler.h>
using namespace gloox;

#include <FL/Fl_Window.H>
#include <string>

class Fl_Text_Buffer;

class XMLConsole : public Fl_Window, LogHandler
{
  public:
    /**
     * Constructor.
     */
    XMLConsole( Client *parent, int x, int y );

    /**
     * Virtual Destructor.
     */
    virtual ~XMLConsole();

    // reimplemented from LogHandler
    virtual void handleLog( LogLevel level, LogArea area, const std::string &xml );

  private:
    Client *m_parent;
    Fl_Text_Buffer *m_buffer;
};

#endif // XMLCONSOLE_H_
